(require 'dbus)
(require 'filenotify)

(defun my-dbus-handler1 ()
  (message "my-dbus-handler1"))

(dbus-register-method
 :session "org.foo" "/org/foo" "org.foo" "Handler1" 'my-dbus-handler1)

(defun my-dbus-handler2 ()
  (write-region "foo" nil "/tmp/foo")
  (message "my-dbus-handler2"))

(dbus-register-method
 :session "org.foo" "/org/foo" "org.foo" "Handler2" 'my-dbus-handler2)

(defun my-notify-callback (event)
  (message "Event %S" event)
  (dbus-call-method :session "org.foo" "/org/foo" "org.foo" "Handler1"))

(file-notify-add-watch
 "/tmp" '(change attribute-change) 'my-notify-callback)

(message
 "Return %s"
 (dbus-call-method :session "org.foo" "/org/foo" "org.foo" "Handler2"))
